/*******************************************************************************
 * Copyright (c) 2000, 2005 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/

/*******************************************************************************
 * Additions/modifications to this source file by Oracle America, Inc. 2011
 *******************************************************************************/

#include "KeyUtils.h"

/**
 * This method converts the incomming UGL keycode to be a native 
 * VK_* keycode.
 */
int KeyUtils_ConvertToNativeKeycode(int keycode) {
	int i=0;
	for (i=0; i < KeyTableSize; i++) {
		if (KeyTable[i][1] == keycode) {
			return KeyTable[i][0];
		}
	}

#ifndef _WIN32_WCE
	{
	LPTSTR lowerChar;
	// The incomming keycodes from Java are captial letters for 
	// the a-z keys, but VkKeyScan returns incorrect values for captial 
	// letters.  The workaround is to convert the keycode to lowercase,
	// which should not affect the other character keys
	lowerChar = CharLower((LPTSTR)keycode);
	return VkKeyScan((WCHAR)lowerChar) & 0x0000FFFF;
	}
#else
	for (i=0; i < WMKeyTableSize; ++i) {
		if (WMKeyTable[i][1] == keycode) {
			return WMKeyTable[i][0];
		}
	} 
	return (int)(CharUpper((LPTSTR)keycode));
#endif
}
