/*******************************************************************************
 * Copyright (c) 2000, 2005 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/

#pragma once
//========================================================================================
#include "Ugl_Win32_widget.h"
#include "UGl_win32_display.h"
#include "UGL_Win32_DC.h"

//========================================================================================
/**
 * Macros for casting.
 */
#define UGL_MENU(handle)				((PUGL_Menu)handle)
#define UGL_MENUITEM(handle)			((PUGL_MenuItem)handle)
//========================================================================================

struct UGL_MenuItem;

typedef struct UGL_Menu {
	UGL_Widget widget;
	struct UGL_Control* parent;
	struct UGL_MenuItem* cascadeItem;	// Only used by drop down menus
	HMENU hMenu;
	int id;

#ifdef _WIN32_WCE
	HWND hwndCB;
	HWND hwndMB; // for softkey with menu
#else
	BOOL isMenuBar;
#endif
} UGL_Menu, *PUGL_Menu;
//========================================================================================

typedef struct UGL_MenuItem {
	UGL_Widget widget;
	PUGL_Menu parent_menu;
	int id;
	PUGL_Image ugl_image;
	PUGL_Menu dropDownMenu; // Only used by CascadeMenuItems
	int index; // new for softkey support
	UGL_String text; // new for softkey support
	BOOL hasSubMenu; // new for softkey support
	BOOL enabled;
	BOOL isSeparator;

	// used to override function if needed
	WM_COMMANDCHILD wmDrawChild;
	WM_COMMANDCHILD wmMeasureChild;
	WM_COMMANDCHILD wmCommandChild;

	LPACCEL accel_entry; // Menu_SetAccelerator-related
} UGL_MenuItem, *PUGL_MenuItem;
//========================================================================================

PUGL_Menu _MenuBar_New(PUGL_Control shell, UGL_Error error);
UGL_Int _PopupMenu_New(UGL_Int shellHandle, UGL_Error uglError);
void _Dispose_Menu(UGL_Int handle, UGL_Error uglError);

